"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  ConcurrentModificationException: () => ConcurrentModificationException,
  ConstraintViolationException: () => ConstraintViolationException,
  DescribeReportCreationCommand: () => DescribeReportCreationCommand,
  ErrorCode: () => ErrorCode,
  GetComplianceSummaryCommand: () => GetComplianceSummaryCommand,
  GetResourcesCommand: () => GetResourcesCommand,
  GetTagKeysCommand: () => GetTagKeysCommand,
  GetTagValuesCommand: () => GetTagValuesCommand,
  GroupByAttribute: () => GroupByAttribute,
  InternalServiceException: () => InternalServiceException,
  InvalidParameterException: () => InvalidParameterException,
  PaginationTokenExpiredException: () => PaginationTokenExpiredException,
  ResourceGroupsTaggingAPI: () => ResourceGroupsTaggingAPI,
  ResourceGroupsTaggingAPIClient: () => ResourceGroupsTaggingAPIClient,
  ResourceGroupsTaggingAPIServiceException: () => ResourceGroupsTaggingAPIServiceException,
  StartReportCreationCommand: () => StartReportCreationCommand,
  TagResourcesCommand: () => TagResourcesCommand,
  TargetIdType: () => TargetIdType,
  ThrottledException: () => ThrottledException,
  UntagResourcesCommand: () => UntagResourcesCommand,
  __Client: () => import_smithy_client.Client,
  paginateGetComplianceSummary: () => paginateGetComplianceSummary,
  paginateGetResources: () => paginateGetResources,
  paginateGetTagKeys: () => paginateGetTagKeys,
  paginateGetTagValues: () => paginateGetTagValues
});
module.exports = __toCommonJS(index_exports);

// src/ResourceGroupsTaggingAPIClient.ts
var import_middleware_host_header = require("@aws-sdk/middleware-host-header");
var import_middleware_logger = require("@aws-sdk/middleware-logger");
var import_middleware_recursion_detection = require("@aws-sdk/middleware-recursion-detection");
var import_middleware_user_agent = require("@aws-sdk/middleware-user-agent");
var import_config_resolver = require("@smithy/config-resolver");
var import_core = require("@smithy/core");
var import_middleware_content_length = require("@smithy/middleware-content-length");
var import_middleware_endpoint = require("@smithy/middleware-endpoint");
var import_middleware_retry = require("@smithy/middleware-retry");

var import_httpAuthSchemeProvider = require("./auth/httpAuthSchemeProvider");

// src/endpoint/EndpointParameters.ts
var resolveClientEndpointParameters = /* @__PURE__ */ __name((options) => {
  return Object.assign(options, {
    useDualstackEndpoint: options.useDualstackEndpoint ?? false,
    useFipsEndpoint: options.useFipsEndpoint ?? false,
    defaultSigningName: "tagging"
  });
}, "resolveClientEndpointParameters");
var commonParams = {
  UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
  Endpoint: { type: "builtInParams", name: "endpoint" },
  Region: { type: "builtInParams", name: "region" },
  UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" }
};

// src/ResourceGroupsTaggingAPIClient.ts
var import_runtimeConfig = require("././runtimeConfig");

// src/runtimeExtensions.ts
var import_region_config_resolver = require("@aws-sdk/region-config-resolver");
var import_protocol_http = require("@smithy/protocol-http");
var import_smithy_client = require("@smithy/smithy-client");

// src/auth/httpAuthExtensionConfiguration.ts
var getHttpAuthExtensionConfiguration = /* @__PURE__ */ __name((runtimeConfig) => {
  const _httpAuthSchemes = runtimeConfig.httpAuthSchemes;
  let _httpAuthSchemeProvider = runtimeConfig.httpAuthSchemeProvider;
  let _credentials = runtimeConfig.credentials;
  return {
    setHttpAuthScheme(httpAuthScheme) {
      const index = _httpAuthSchemes.findIndex((scheme) => scheme.schemeId === httpAuthScheme.schemeId);
      if (index === -1) {
        _httpAuthSchemes.push(httpAuthScheme);
      } else {
        _httpAuthSchemes.splice(index, 1, httpAuthScheme);
      }
    },
    httpAuthSchemes() {
      return _httpAuthSchemes;
    },
    setHttpAuthSchemeProvider(httpAuthSchemeProvider) {
      _httpAuthSchemeProvider = httpAuthSchemeProvider;
    },
    httpAuthSchemeProvider() {
      return _httpAuthSchemeProvider;
    },
    setCredentials(credentials) {
      _credentials = credentials;
    },
    credentials() {
      return _credentials;
    }
  };
}, "getHttpAuthExtensionConfiguration");
var resolveHttpAuthRuntimeConfig = /* @__PURE__ */ __name((config) => {
  return {
    httpAuthSchemes: config.httpAuthSchemes(),
    httpAuthSchemeProvider: config.httpAuthSchemeProvider(),
    credentials: config.credentials()
  };
}, "resolveHttpAuthRuntimeConfig");

// src/runtimeExtensions.ts
var resolveRuntimeExtensions = /* @__PURE__ */ __name((runtimeConfig, extensions) => {
  const extensionConfiguration = Object.assign(
    (0, import_region_config_resolver.getAwsRegionExtensionConfiguration)(runtimeConfig),
    (0, import_smithy_client.getDefaultExtensionConfiguration)(runtimeConfig),
    (0, import_protocol_http.getHttpHandlerExtensionConfiguration)(runtimeConfig),
    getHttpAuthExtensionConfiguration(runtimeConfig)
  );
  extensions.forEach((extension) => extension.configure(extensionConfiguration));
  return Object.assign(
    runtimeConfig,
    (0, import_region_config_resolver.resolveAwsRegionExtensionConfiguration)(extensionConfiguration),
    (0, import_smithy_client.resolveDefaultRuntimeConfig)(extensionConfiguration),
    (0, import_protocol_http.resolveHttpHandlerRuntimeConfig)(extensionConfiguration),
    resolveHttpAuthRuntimeConfig(extensionConfiguration)
  );
}, "resolveRuntimeExtensions");

// src/ResourceGroupsTaggingAPIClient.ts
var ResourceGroupsTaggingAPIClient = class extends import_smithy_client.Client {
  static {
    __name(this, "ResourceGroupsTaggingAPIClient");
  }
  /**
   * The resolved configuration of ResourceGroupsTaggingAPIClient class. This is resolved and normalized from the {@link ResourceGroupsTaggingAPIClientConfig | constructor configuration interface}.
   */
  config;
  constructor(...[configuration]) {
    const _config_0 = (0, import_runtimeConfig.getRuntimeConfig)(configuration || {});
    super(_config_0);
    this.initConfig = _config_0;
    const _config_1 = resolveClientEndpointParameters(_config_0);
    const _config_2 = (0, import_middleware_user_agent.resolveUserAgentConfig)(_config_1);
    const _config_3 = (0, import_middleware_retry.resolveRetryConfig)(_config_2);
    const _config_4 = (0, import_config_resolver.resolveRegionConfig)(_config_3);
    const _config_5 = (0, import_middleware_host_header.resolveHostHeaderConfig)(_config_4);
    const _config_6 = (0, import_middleware_endpoint.resolveEndpointConfig)(_config_5);
    const _config_7 = (0, import_httpAuthSchemeProvider.resolveHttpAuthSchemeConfig)(_config_6);
    const _config_8 = resolveRuntimeExtensions(_config_7, configuration?.extensions || []);
    this.config = _config_8;
    this.middlewareStack.use((0, import_middleware_user_agent.getUserAgentPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_retry.getRetryPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_content_length.getContentLengthPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_host_header.getHostHeaderPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_logger.getLoggerPlugin)(this.config));
    this.middlewareStack.use((0, import_middleware_recursion_detection.getRecursionDetectionPlugin)(this.config));
    this.middlewareStack.use(
      (0, import_core.getHttpAuthSchemeEndpointRuleSetPlugin)(this.config, {
        httpAuthSchemeParametersProvider: import_httpAuthSchemeProvider.defaultResourceGroupsTaggingAPIHttpAuthSchemeParametersProvider,
        identityProviderConfigProvider: /* @__PURE__ */ __name(async (config) => new import_core.DefaultIdentityProviderConfig({
          "aws.auth#sigv4": config.credentials
        }), "identityProviderConfigProvider")
      })
    );
    this.middlewareStack.use((0, import_core.getHttpSigningPlugin)(this.config));
  }
  /**
   * Destroy underlying resources, like sockets. It's usually not necessary to do this.
   * However in Node.js, it's best to explicitly shut down the client's agent when it is no longer needed.
   * Otherwise, sockets might stay open for quite a long time before the server terminates them.
   */
  destroy() {
    super.destroy();
  }
};

// src/ResourceGroupsTaggingAPI.ts


// src/commands/DescribeReportCreationCommand.ts

var import_middleware_serde = require("@smithy/middleware-serde");


// src/protocols/Aws_json1_1.ts
var import_core2 = require("@aws-sdk/core");



// src/models/ResourceGroupsTaggingAPIServiceException.ts

var ResourceGroupsTaggingAPIServiceException = class _ResourceGroupsTaggingAPIServiceException extends import_smithy_client.ServiceException {
  static {
    __name(this, "ResourceGroupsTaggingAPIServiceException");
  }
  /**
   * @internal
   */
  constructor(options) {
    super(options);
    Object.setPrototypeOf(this, _ResourceGroupsTaggingAPIServiceException.prototype);
  }
};

// src/models/models_0.ts
var ConcurrentModificationException = class _ConcurrentModificationException extends ResourceGroupsTaggingAPIServiceException {
  static {
    __name(this, "ConcurrentModificationException");
  }
  name = "ConcurrentModificationException";
  $fault = "client";
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ConcurrentModificationException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ConcurrentModificationException.prototype);
    this.Message = opts.Message;
  }
};
var ConstraintViolationException = class _ConstraintViolationException extends ResourceGroupsTaggingAPIServiceException {
  static {
    __name(this, "ConstraintViolationException");
  }
  name = "ConstraintViolationException";
  $fault = "client";
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ConstraintViolationException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ConstraintViolationException.prototype);
    this.Message = opts.Message;
  }
};
var InternalServiceException = class _InternalServiceException extends ResourceGroupsTaggingAPIServiceException {
  static {
    __name(this, "InternalServiceException");
  }
  name = "InternalServiceException";
  $fault = "server";
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "InternalServiceException",
      $fault: "server",
      ...opts
    });
    Object.setPrototypeOf(this, _InternalServiceException.prototype);
    this.Message = opts.Message;
  }
};
var InvalidParameterException = class _InvalidParameterException extends ResourceGroupsTaggingAPIServiceException {
  static {
    __name(this, "InvalidParameterException");
  }
  name = "InvalidParameterException";
  $fault = "client";
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "InvalidParameterException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _InvalidParameterException.prototype);
    this.Message = opts.Message;
  }
};
var ThrottledException = class _ThrottledException extends ResourceGroupsTaggingAPIServiceException {
  static {
    __name(this, "ThrottledException");
  }
  name = "ThrottledException";
  $fault = "client";
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "ThrottledException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _ThrottledException.prototype);
    this.Message = opts.Message;
  }
};
var ErrorCode = {
  INTERNAL_SERVICE_EXCEPTION: "InternalServiceException",
  INVALID_PARAMETER_EXCEPTION: "InvalidParameterException"
};
var GroupByAttribute = {
  REGION: "REGION",
  RESOURCE_TYPE: "RESOURCE_TYPE",
  TARGET_ID: "TARGET_ID"
};
var TargetIdType = {
  ACCOUNT: "ACCOUNT",
  OU: "OU",
  ROOT: "ROOT"
};
var PaginationTokenExpiredException = class _PaginationTokenExpiredException extends ResourceGroupsTaggingAPIServiceException {
  static {
    __name(this, "PaginationTokenExpiredException");
  }
  name = "PaginationTokenExpiredException";
  $fault = "client";
  Message;
  /**
   * @internal
   */
  constructor(opts) {
    super({
      name: "PaginationTokenExpiredException",
      $fault: "client",
      ...opts
    });
    Object.setPrototypeOf(this, _PaginationTokenExpiredException.prototype);
    this.Message = opts.Message;
  }
};

// src/protocols/Aws_json1_1.ts
var se_DescribeReportCreationCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("DescribeReportCreation");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_DescribeReportCreationCommand");
var se_GetComplianceSummaryCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("GetComplianceSummary");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_GetComplianceSummaryCommand");
var se_GetResourcesCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("GetResources");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_GetResourcesCommand");
var se_GetTagKeysCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("GetTagKeys");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_GetTagKeysCommand");
var se_GetTagValuesCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("GetTagValues");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_GetTagValuesCommand");
var se_StartReportCreationCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("StartReportCreation");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_StartReportCreationCommand");
var se_TagResourcesCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("TagResources");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_TagResourcesCommand");
var se_UntagResourcesCommand = /* @__PURE__ */ __name(async (input, context) => {
  const headers = sharedHeaders("UntagResources");
  let body;
  body = JSON.stringify((0, import_smithy_client._json)(input));
  return buildHttpRpcRequest(context, headers, "/", void 0, body);
}, "se_UntagResourcesCommand");
var de_DescribeReportCreationCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_DescribeReportCreationCommand");
var de_GetComplianceSummaryCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_GetComplianceSummaryCommand");
var de_GetResourcesCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_GetResourcesCommand");
var de_GetTagKeysCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_GetTagKeysCommand");
var de_GetTagValuesCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_GetTagValuesCommand");
var de_StartReportCreationCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_StartReportCreationCommand");
var de_TagResourcesCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_TagResourcesCommand");
var de_UntagResourcesCommand = /* @__PURE__ */ __name(async (output, context) => {
  if (output.statusCode >= 300) {
    return de_CommandError(output, context);
  }
  const data = await (0, import_core2.parseJsonBody)(output.body, context);
  let contents = {};
  contents = (0, import_smithy_client._json)(data);
  const response = {
    $metadata: deserializeMetadata(output),
    ...contents
  };
  return response;
}, "de_UntagResourcesCommand");
var de_CommandError = /* @__PURE__ */ __name(async (output, context) => {
  const parsedOutput = {
    ...output,
    body: await (0, import_core2.parseJsonErrorBody)(output.body, context)
  };
  const errorCode = (0, import_core2.loadRestJsonErrorCode)(output, parsedOutput.body);
  switch (errorCode) {
    case "ConstraintViolationException":
    case "com.amazonaws.resourcegroupstaggingapi#ConstraintViolationException":
      throw await de_ConstraintViolationExceptionRes(parsedOutput, context);
    case "InternalServiceException":
    case "com.amazonaws.resourcegroupstaggingapi#InternalServiceException":
      throw await de_InternalServiceExceptionRes(parsedOutput, context);
    case "InvalidParameterException":
    case "com.amazonaws.resourcegroupstaggingapi#InvalidParameterException":
      throw await de_InvalidParameterExceptionRes(parsedOutput, context);
    case "ThrottledException":
    case "com.amazonaws.resourcegroupstaggingapi#ThrottledException":
      throw await de_ThrottledExceptionRes(parsedOutput, context);
    case "PaginationTokenExpiredException":
    case "com.amazonaws.resourcegroupstaggingapi#PaginationTokenExpiredException":
      throw await de_PaginationTokenExpiredExceptionRes(parsedOutput, context);
    case "ConcurrentModificationException":
    case "com.amazonaws.resourcegroupstaggingapi#ConcurrentModificationException":
      throw await de_ConcurrentModificationExceptionRes(parsedOutput, context);
    default:
      const parsedBody = parsedOutput.body;
      return throwDefaultError({
        output,
        parsedBody,
        errorCode
      });
  }
}, "de_CommandError");
var de_ConcurrentModificationExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = (0, import_smithy_client._json)(body);
  const exception = new ConcurrentModificationException({
    $metadata: deserializeMetadata(parsedOutput),
    ...deserialized
  });
  return (0, import_smithy_client.decorateServiceException)(exception, body);
}, "de_ConcurrentModificationExceptionRes");
var de_ConstraintViolationExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = (0, import_smithy_client._json)(body);
  const exception = new ConstraintViolationException({
    $metadata: deserializeMetadata(parsedOutput),
    ...deserialized
  });
  return (0, import_smithy_client.decorateServiceException)(exception, body);
}, "de_ConstraintViolationExceptionRes");
var de_InternalServiceExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = (0, import_smithy_client._json)(body);
  const exception = new InternalServiceException({
    $metadata: deserializeMetadata(parsedOutput),
    ...deserialized
  });
  return (0, import_smithy_client.decorateServiceException)(exception, body);
}, "de_InternalServiceExceptionRes");
var de_InvalidParameterExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = (0, import_smithy_client._json)(body);
  const exception = new InvalidParameterException({
    $metadata: deserializeMetadata(parsedOutput),
    ...deserialized
  });
  return (0, import_smithy_client.decorateServiceException)(exception, body);
}, "de_InvalidParameterExceptionRes");
var de_PaginationTokenExpiredExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = (0, import_smithy_client._json)(body);
  const exception = new PaginationTokenExpiredException({
    $metadata: deserializeMetadata(parsedOutput),
    ...deserialized
  });
  return (0, import_smithy_client.decorateServiceException)(exception, body);
}, "de_PaginationTokenExpiredExceptionRes");
var de_ThrottledExceptionRes = /* @__PURE__ */ __name(async (parsedOutput, context) => {
  const body = parsedOutput.body;
  const deserialized = (0, import_smithy_client._json)(body);
  const exception = new ThrottledException({
    $metadata: deserializeMetadata(parsedOutput),
    ...deserialized
  });
  return (0, import_smithy_client.decorateServiceException)(exception, body);
}, "de_ThrottledExceptionRes");
var deserializeMetadata = /* @__PURE__ */ __name((output) => ({
  httpStatusCode: output.statusCode,
  requestId: output.headers["x-amzn-requestid"] ?? output.headers["x-amzn-request-id"] ?? output.headers["x-amz-request-id"],
  extendedRequestId: output.headers["x-amz-id-2"],
  cfId: output.headers["x-amz-cf-id"]
}), "deserializeMetadata");
var throwDefaultError = (0, import_smithy_client.withBaseException)(ResourceGroupsTaggingAPIServiceException);
var buildHttpRpcRequest = /* @__PURE__ */ __name(async (context, headers, path, resolvedHostname, body) => {
  const { hostname, protocol = "https", port, path: basePath } = await context.endpoint();
  const contents = {
    protocol,
    hostname,
    port,
    method: "POST",
    path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
    headers
  };
  if (resolvedHostname !== void 0) {
    contents.hostname = resolvedHostname;
  }
  if (body !== void 0) {
    contents.body = body;
  }
  return new import_protocol_http.HttpRequest(contents);
}, "buildHttpRpcRequest");
function sharedHeaders(operation) {
  return {
    "content-type": "application/x-amz-json-1.1",
    "x-amz-target": `ResourceGroupsTaggingAPI_20170126.${operation}`
  };
}
__name(sharedHeaders, "sharedHeaders");

// src/commands/DescribeReportCreationCommand.ts
var DescribeReportCreationCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "DescribeReportCreation", {}).n("ResourceGroupsTaggingAPIClient", "DescribeReportCreationCommand").f(void 0, void 0).ser(se_DescribeReportCreationCommand).de(de_DescribeReportCreationCommand).build() {
  static {
    __name(this, "DescribeReportCreationCommand");
  }
};

// src/commands/GetComplianceSummaryCommand.ts



var GetComplianceSummaryCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "GetComplianceSummary", {}).n("ResourceGroupsTaggingAPIClient", "GetComplianceSummaryCommand").f(void 0, void 0).ser(se_GetComplianceSummaryCommand).de(de_GetComplianceSummaryCommand).build() {
  static {
    __name(this, "GetComplianceSummaryCommand");
  }
};

// src/commands/GetResourcesCommand.ts



var GetResourcesCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "GetResources", {}).n("ResourceGroupsTaggingAPIClient", "GetResourcesCommand").f(void 0, void 0).ser(se_GetResourcesCommand).de(de_GetResourcesCommand).build() {
  static {
    __name(this, "GetResourcesCommand");
  }
};

// src/commands/GetTagKeysCommand.ts



var GetTagKeysCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "GetTagKeys", {}).n("ResourceGroupsTaggingAPIClient", "GetTagKeysCommand").f(void 0, void 0).ser(se_GetTagKeysCommand).de(de_GetTagKeysCommand).build() {
  static {
    __name(this, "GetTagKeysCommand");
  }
};

// src/commands/GetTagValuesCommand.ts



var GetTagValuesCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "GetTagValues", {}).n("ResourceGroupsTaggingAPIClient", "GetTagValuesCommand").f(void 0, void 0).ser(se_GetTagValuesCommand).de(de_GetTagValuesCommand).build() {
  static {
    __name(this, "GetTagValuesCommand");
  }
};

// src/commands/StartReportCreationCommand.ts



var StartReportCreationCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "StartReportCreation", {}).n("ResourceGroupsTaggingAPIClient", "StartReportCreationCommand").f(void 0, void 0).ser(se_StartReportCreationCommand).de(de_StartReportCreationCommand).build() {
  static {
    __name(this, "StartReportCreationCommand");
  }
};

// src/commands/TagResourcesCommand.ts



var TagResourcesCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "TagResources", {}).n("ResourceGroupsTaggingAPIClient", "TagResourcesCommand").f(void 0, void 0).ser(se_TagResourcesCommand).de(de_TagResourcesCommand).build() {
  static {
    __name(this, "TagResourcesCommand");
  }
};

// src/commands/UntagResourcesCommand.ts



var UntagResourcesCommand = class extends import_smithy_client.Command.classBuilder().ep(commonParams).m(function(Command, cs, config, o) {
  return [
    (0, import_middleware_serde.getSerdePlugin)(config, this.serialize, this.deserialize),
    (0, import_middleware_endpoint.getEndpointPlugin)(config, Command.getEndpointParameterInstructions())
  ];
}).s("ResourceGroupsTaggingAPI_20170126", "UntagResources", {}).n("ResourceGroupsTaggingAPIClient", "UntagResourcesCommand").f(void 0, void 0).ser(se_UntagResourcesCommand).de(de_UntagResourcesCommand).build() {
  static {
    __name(this, "UntagResourcesCommand");
  }
};

// src/ResourceGroupsTaggingAPI.ts
var commands = {
  DescribeReportCreationCommand,
  GetComplianceSummaryCommand,
  GetResourcesCommand,
  GetTagKeysCommand,
  GetTagValuesCommand,
  StartReportCreationCommand,
  TagResourcesCommand,
  UntagResourcesCommand
};
var ResourceGroupsTaggingAPI = class extends ResourceGroupsTaggingAPIClient {
  static {
    __name(this, "ResourceGroupsTaggingAPI");
  }
};
(0, import_smithy_client.createAggregatedClient)(commands, ResourceGroupsTaggingAPI);

// src/pagination/GetComplianceSummaryPaginator.ts

var paginateGetComplianceSummary = (0, import_core.createPaginator)(ResourceGroupsTaggingAPIClient, GetComplianceSummaryCommand, "PaginationToken", "PaginationToken", "MaxResults");

// src/pagination/GetResourcesPaginator.ts

var paginateGetResources = (0, import_core.createPaginator)(ResourceGroupsTaggingAPIClient, GetResourcesCommand, "PaginationToken", "PaginationToken", "ResourcesPerPage");

// src/pagination/GetTagKeysPaginator.ts

var paginateGetTagKeys = (0, import_core.createPaginator)(ResourceGroupsTaggingAPIClient, GetTagKeysCommand, "PaginationToken", "PaginationToken", "");

// src/pagination/GetTagValuesPaginator.ts

var paginateGetTagValues = (0, import_core.createPaginator)(ResourceGroupsTaggingAPIClient, GetTagValuesCommand, "PaginationToken", "PaginationToken", "");
// Annotate the CommonJS export names for ESM import in node:

0 && (module.exports = {
  ResourceGroupsTaggingAPIServiceException,
  __Client,
  ResourceGroupsTaggingAPIClient,
  ResourceGroupsTaggingAPI,
  $Command,
  DescribeReportCreationCommand,
  GetComplianceSummaryCommand,
  GetResourcesCommand,
  GetTagKeysCommand,
  GetTagValuesCommand,
  StartReportCreationCommand,
  TagResourcesCommand,
  UntagResourcesCommand,
  paginateGetComplianceSummary,
  paginateGetResources,
  paginateGetTagKeys,
  paginateGetTagValues,
  ConcurrentModificationException,
  ConstraintViolationException,
  InternalServiceException,
  InvalidParameterException,
  ThrottledException,
  ErrorCode,
  GroupByAttribute,
  TargetIdType,
  PaginationTokenExpiredException
});

