import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetComplianceSummaryCommand, se_GetComplianceSummaryCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class GetComplianceSummaryCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ResourceGroupsTaggingAPI_20170126", "GetComplianceSummary", {})
    .n("ResourceGroupsTaggingAPIClient", "GetComplianceSummaryCommand")
    .f(void 0, void 0)
    .ser(se_GetComplianceSummaryCommand)
    .de(de_GetComplianceSummaryCommand)
    .build() {
}
