import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_TagResourcesCommand, se_TagResourcesCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class TagResourcesCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ResourceGroupsTaggingAPI_20170126", "TagResources", {})
    .n("ResourceGroupsTaggingAPIClient", "TagResourcesCommand")
    .f(void 0, void 0)
    .ser(se_TagResourcesCommand)
    .de(de_TagResourcesCommand)
    .build() {
}
