import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_UntagResourcesCommand, se_UntagResourcesCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class UntagResourcesCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("ResourceGroupsTaggingAPI_20170126", "UntagResources", {})
    .n("ResourceGroupsTaggingAPIClient", "UntagResourcesCommand")
    .f(void 0, void 0)
    .ser(se_UntagResourcesCommand)
    .de(de_UntagResourcesCommand)
    .build() {
}
