import { ResourceGroupsTaggingAPIServiceException as __BaseException } from "./ResourceGroupsTaggingAPIServiceException";
export class ConcurrentModificationException extends __BaseException {
    name = "ConcurrentModificationException";
    $fault = "client";
    Message;
    constructor(opts) {
        super({
            name: "ConcurrentModificationException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ConcurrentModificationException.prototype);
        this.Message = opts.Message;
    }
}
export class ConstraintViolationException extends __BaseException {
    name = "ConstraintViolationException";
    $fault = "client";
    Message;
    constructor(opts) {
        super({
            name: "ConstraintViolationException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ConstraintViolationException.prototype);
        this.Message = opts.Message;
    }
}
export class InternalServiceException extends __BaseException {
    name = "InternalServiceException";
    $fault = "server";
    Message;
    constructor(opts) {
        super({
            name: "InternalServiceException",
            $fault: "server",
            ...opts,
        });
        Object.setPrototypeOf(this, InternalServiceException.prototype);
        this.Message = opts.Message;
    }
}
export class InvalidParameterException extends __BaseException {
    name = "InvalidParameterException";
    $fault = "client";
    Message;
    constructor(opts) {
        super({
            name: "InvalidParameterException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, InvalidParameterException.prototype);
        this.Message = opts.Message;
    }
}
export class ThrottledException extends __BaseException {
    name = "ThrottledException";
    $fault = "client";
    Message;
    constructor(opts) {
        super({
            name: "ThrottledException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, ThrottledException.prototype);
        this.Message = opts.Message;
    }
}
export const ErrorCode = {
    INTERNAL_SERVICE_EXCEPTION: "InternalServiceException",
    INVALID_PARAMETER_EXCEPTION: "InvalidParameterException",
};
export const GroupByAttribute = {
    REGION: "REGION",
    RESOURCE_TYPE: "RESOURCE_TYPE",
    TARGET_ID: "TARGET_ID",
};
export const TargetIdType = {
    ACCOUNT: "ACCOUNT",
    OU: "OU",
    ROOT: "ROOT",
};
export class PaginationTokenExpiredException extends __BaseException {
    name = "PaginationTokenExpiredException";
    $fault = "client";
    Message;
    constructor(opts) {
        super({
            name: "PaginationTokenExpiredException",
            $fault: "client",
            ...opts,
        });
        Object.setPrototypeOf(this, PaginationTokenExpiredException.prototype);
        this.Message = opts.Message;
    }
}
