import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { ResourceGroupsTaggingAPIClientResolvedConfig } from "../ResourceGroupsTaggingAPIClient";
export interface ResourceGroupsTaggingAPIHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface ResourceGroupsTaggingAPIHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    ResourceGroupsTaggingAPIClientResolvedConfig,
    HandlerExecutionContext,
    ResourceGroupsTaggingAPIHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultResourceGroupsTaggingAPIHttpAuthSchemeParametersProvider: (
  config: ResourceGroupsTaggingAPIClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<ResourceGroupsTaggingAPIHttpAuthSchemeParameters>;
export interface ResourceGroupsTaggingAPIHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<ResourceGroupsTaggingAPIHttpAuthSchemeParameters> {}
export declare const defaultResourceGroupsTaggingAPIHttpAuthSchemeProvider: ResourceGroupsTaggingAPIHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: ResourceGroupsTaggingAPIHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: ResourceGroupsTaggingAPIHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
