import { ExceptionOptionType as __ExceptionOptionType } from "@smithy/smithy-client";
import { ResourceGroupsTaggingAPIServiceException as __BaseException } from "./ResourceGroupsTaggingAPIServiceException";
export interface ComplianceDetails {
  NoncompliantKeys?: string[] | undefined;
  KeysWithNoncompliantValues?: string[] | undefined;
  ComplianceStatus?: boolean | undefined;
}
export declare class ConcurrentModificationException extends __BaseException {
  readonly name: "ConcurrentModificationException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<
      ConcurrentModificationException,
      __BaseException
    >
  );
}
export declare class ConstraintViolationException extends __BaseException {
  readonly name: "ConstraintViolationException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<ConstraintViolationException, __BaseException>
  );
}
export interface DescribeReportCreationInput {}
export interface DescribeReportCreationOutput {
  Status?: string | undefined;
  S3Location?: string | undefined;
  StartDate?: string | undefined;
  ErrorMessage?: string | undefined;
}
export declare class InternalServiceException extends __BaseException {
  readonly name: "InternalServiceException";
  readonly $fault: "server";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<InternalServiceException, __BaseException>
  );
}
export declare class InvalidParameterException extends __BaseException {
  readonly name: "InvalidParameterException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<InvalidParameterException, __BaseException>
  );
}
export declare class ThrottledException extends __BaseException {
  readonly name: "ThrottledException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(opts: __ExceptionOptionType<ThrottledException, __BaseException>);
}
export declare const ErrorCode: {
  readonly INTERNAL_SERVICE_EXCEPTION: "InternalServiceException";
  readonly INVALID_PARAMETER_EXCEPTION: "InvalidParameterException";
};
export type ErrorCode = (typeof ErrorCode)[keyof typeof ErrorCode];
export interface FailureInfo {
  StatusCode?: number | undefined;
  ErrorCode?: ErrorCode | undefined;
  ErrorMessage?: string | undefined;
}
export declare const GroupByAttribute: {
  readonly REGION: "REGION";
  readonly RESOURCE_TYPE: "RESOURCE_TYPE";
  readonly TARGET_ID: "TARGET_ID";
};
export type GroupByAttribute =
  (typeof GroupByAttribute)[keyof typeof GroupByAttribute];
export interface GetComplianceSummaryInput {
  TargetIdFilters?: string[] | undefined;
  RegionFilters?: string[] | undefined;
  ResourceTypeFilters?: string[] | undefined;
  TagKeyFilters?: string[] | undefined;
  GroupBy?: GroupByAttribute[] | undefined;
  MaxResults?: number | undefined;
  PaginationToken?: string | undefined;
}
export declare const TargetIdType: {
  readonly ACCOUNT: "ACCOUNT";
  readonly OU: "OU";
  readonly ROOT: "ROOT";
};
export type TargetIdType = (typeof TargetIdType)[keyof typeof TargetIdType];
export interface Summary {
  LastUpdated?: string | undefined;
  TargetId?: string | undefined;
  TargetIdType?: TargetIdType | undefined;
  Region?: string | undefined;
  ResourceType?: string | undefined;
  NonCompliantResources?: number | undefined;
}
export interface GetComplianceSummaryOutput {
  SummaryList?: Summary[] | undefined;
  PaginationToken?: string | undefined;
}
export interface TagFilter {
  Key?: string | undefined;
  Values?: string[] | undefined;
}
export interface GetResourcesInput {
  PaginationToken?: string | undefined;
  TagFilters?: TagFilter[] | undefined;
  ResourcesPerPage?: number | undefined;
  TagsPerPage?: number | undefined;
  ResourceTypeFilters?: string[] | undefined;
  IncludeComplianceDetails?: boolean | undefined;
  ExcludeCompliantResources?: boolean | undefined;
  ResourceARNList?: string[] | undefined;
}
export interface Tag {
  Key: string | undefined;
  Value: string | undefined;
}
export interface ResourceTagMapping {
  ResourceARN?: string | undefined;
  Tags?: Tag[] | undefined;
  ComplianceDetails?: ComplianceDetails | undefined;
}
export interface GetResourcesOutput {
  PaginationToken?: string | undefined;
  ResourceTagMappingList?: ResourceTagMapping[] | undefined;
}
export declare class PaginationTokenExpiredException extends __BaseException {
  readonly name: "PaginationTokenExpiredException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<
      PaginationTokenExpiredException,
      __BaseException
    >
  );
}
export interface GetTagKeysInput {
  PaginationToken?: string | undefined;
}
export interface GetTagKeysOutput {
  PaginationToken?: string | undefined;
  TagKeys?: string[] | undefined;
}
export interface GetTagValuesInput {
  PaginationToken?: string | undefined;
  Key: string | undefined;
}
export interface GetTagValuesOutput {
  PaginationToken?: string | undefined;
  TagValues?: string[] | undefined;
}
export interface StartReportCreationInput {
  S3Bucket: string | undefined;
}
export interface StartReportCreationOutput {}
export interface TagResourcesInput {
  ResourceARNList: string[] | undefined;
  Tags: Record<string, string> | undefined;
}
export interface TagResourcesOutput {
  FailedResourcesMap?: Record<string, FailureInfo> | undefined;
}
export interface UntagResourcesInput {
  ResourceARNList: string[] | undefined;
  TagKeys: string[] | undefined;
}
export interface UntagResourcesOutput {
  FailedResourcesMap?: Record<string, FailureInfo> | undefined;
}
